
-- +migrate Up notransaction

-- add clusters maintenance status
ALTER TYPE "cluster_status" ADD VALUE IF NOT EXISTS 'MAINTENANCE';

-- add maintenance boolean flag for cluster
ALTER TABLE "clusters" ADD COLUMN "maintenance" BOOLEAN NOT NULL DEFAULT 'false';

-- create clusters maintenance table

CREATE TABLE "clusters_maintenance" (
    "id" uuid PRIMARY KEY DEFAULT (uuid_generate_v4()),
    "cluster_id" uuid NOT NULL,
    "start_time" time NOT NULL DEFAULT '01:00:00',
    "end_time" time NOT NULL DEFAULT '05:00:00',
    "last_maintenance_start" timestamp
);

ALTER TABLE "clusters_maintenance" ADD FOREIGN KEY ("cluster_id") REFERENCES "clusters" ("id");

CREATE UNIQUE INDEX ON "clusters_maintenance" ("cluster_id");

-- add all existing clusters into clusters maintenance table

INSERT INTO "clusters_maintenance" ("cluster_id")
SELECT "id"
FROM "clusters";

-- +migrate Down

-- don't delete clusters maintenance status since some clusters can have this status after adding this value in enum

-- drop maintenance boolean flag for cluster
ALTER TABLE "clusters" DROP COLUMN "maintenance";

-- drop clusters maintenance table
DROP TABLE "clusters_maintenance";